#include "narfi.h"

static int NEW_NAME_ERROR = 2;
static int ERROR_CODE = 1;

int counting(char *file_name, long z, int separator, int field_count, BOOL remove_separators) {
    char *combo;
    char *p;
    char few_fields;
    DIVIDING dividing;
    DIVIDING *d = &dividing;
    FILE *file;
    int buffer_size = (int)z;
    int exit_code = 0;
    int shared_field_count;
    LEAF *left = NULL;
    char *buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-14: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    combo = malloc( MINIMUM_COMBO_SIZE + buffer_size );
    if(combo == NULL) {
        fprintf(stderr, "malloc() error-15: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "fopen() error: %s\n", file_name);
        return ERROR_CODE;
    }

    if(field_count <= 0x00FF) { /* 0 to 255 */
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            return ERROR_CODE;
        }

        full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
        left = mapping_fields_list(d, buffer);
        shared_field_count = d->field_count;
        lose_leaves(left);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
            left = mapping_fields_list(d, buffer);
            if(d->field_count != shared_field_count) {
                unite_fields(d, left, buffer, combo);
                fprintf(stdout, "%s\n", combo);
            }

            release_arrays(d);
        }

    } else {
        p = fgets(buffer, buffer_size, file);
        if(p == NULL) {
            return ERROR_CODE;
        }

        full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
        left = mapping_fields_list(d, buffer);
        shared_field_count = d->field_count;
        lose_leaves(left);

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
            left = mapping_fields_list(d, buffer);
            if(d->field_count != shared_field_count) {
                unite_fields(d, left, buffer, combo);
                fprintf(stdout, "%s\n", combo);
            }

            release_arrays(d);
        }

    }

    fclose(file);
    free(buffer);
    return exit_code;
}

int standard_input_output_counting(long z, int separator, int field_count, BOOL remove_separators) {
    char *combo;
    char *p;
    char few_fields;
    DIVIDING dividing;
    DIVIDING *d = &dividing;
    int buffer_size = (int)z;
    int exit_code = 0;
    int shared_field_count;
    LEAF *left = NULL;
    char *buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-16: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    combo = malloc( MINIMUM_COMBO_SIZE + buffer_size );
    if(combo == NULL) {
        fprintf(stderr, "combo == NULL error-3: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    if(field_count <= 0x00FF) { /* 0 to 255 */
        few_fields = (char)field_count;

        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            return ERROR_CODE;
        }

        full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
        mapping_fields_list(d, buffer);
/*        left = mapping_fields_list(d, buffer); */
        shared_field_count = d->field_count;
/*        lose_leaves(left); */

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
            mapping_fields_list(d, buffer);
/*            left = mapping_fields_list(d, buffer); */
            if(d->field_count != shared_field_count) {
                unite_fields(d, left, buffer, combo);
                fprintf(stdout, "%s\n", combo);
            }

            release_arrays(d);
        }

    } else {
        p = fgets(buffer, buffer_size, stdin);
        if(p == NULL) {
            return ERROR_CODE;
        }

        full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
        mapping_fields_list(d, buffer);
/*        left = mapping_fields_list(d, buffer); */
        shared_field_count = d->field_count;
/*        lose_leaves(left); */

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
            mapping_fields_list(d, buffer);
/*            left = mapping_fields_list(d, buffer); */
            if(d->field_count != shared_field_count) {
                unite_fields(d, left, buffer, combo);
                fprintf(stdout, "%s\n", combo);
            }

            release_arrays(d);
        }

    }

    free(buffer);
    free(combo);
    return exit_code;
}

