#include "narfi.h"

void version_guide(double v, BOOL comments) {
    fprintf(stderr, "narfi C-%1.3f\n\n", v);

    if(comments) {
        fprintf(stderr, "narfi -c4 wide             # Produce narfi.txt that has 4 fields. \n");
        fprintf(stderr, "narfi -c4 wide narrow      # Produce a narrow file that has 4 fields. \n");
        fprintf(stderr, "narfi -c4 < wide > narrow  # Produce a narrow file that has 4 fields. \n");
        fprintf(stderr, "narfi -c4 -b1011 wide      # narfi.txt has Field-1, Field-3 and Field-4. \n");
        fprintf(stderr, "narfi -c4 -e2 wide         # Extract a decimal from Field-2. \n");
        fprintf(stderr, "narfi -c4 -i2-3 wide       # narfi.txt has Field-2 and Field-3. \n");
        fprintf(stderr, "narfi -c4 -k2 -a_ wide     # In Field-2, narfi replaces katakana with ascii.\n");
        fprintf(stderr, "narfi -c4 -l wide          # Show how large the buffer is. \n");
        fprintf(stderr, "narfi -c4 -n2 wide         # Extract an integer from Field-2. \n");
        fprintf(stderr, "narfi -c4 -o2 wide         # Remove control characters from Field-2. \n");
        fprintf(stderr, "narfi -c4 -q wide          # Commas disappear if placed in quotes. \n");
        fprintf(stderr, "narfi -c4 -r wide          # Arrange fields in reverse order. \n");
        fprintf(stderr, "narfi -c4 -s, wide         # CSV \n");
        fprintf(stderr, "narfi -c4 -s\\l wide        # Wiki table \n");
        fprintf(stderr, "narfi -c4 -s\\l -x- csv     # Do not check if the file name includes .csv \n");
        fprintf(stderr, "narfi -c4 -s\\x7C wide      # Wiki table \n");
        fprintf(stderr, "narfi -c4 -z256 wide       # Use a buffer of 256 bytes. \n");
        fprintf(stderr, "narfi -c255 -f wide        # Check if all lines share the field count. \n");
        fprintf(stderr, "narfi -V                   # version \n");
        fprintf(stderr, "narfi -VC                  # version with comments \n");
    } else {
        fprintf(stderr, "narfi -c4 wide             \n");
        fprintf(stderr, "narfi -c4 wide narrow      \n");
        fprintf(stderr, "narfi -c4 < wide > narrow  \n");
        fprintf(stderr, "narfi -c4 -b1011 wide      \n");
        fprintf(stderr, "narfi -c4 -e2 wide         \n");
        fprintf(stderr, "narfi -c4 -i2-3 wide       \n");
        fprintf(stderr, "narfi -c4 -k2 -a_ wide     \n");
        fprintf(stderr, "narfi -c4 -l wide          \n");
        fprintf(stderr, "narfi -c4 -n2 wide         \n");
        fprintf(stderr, "narfi -c4 -o2 wide         \n");
        fprintf(stderr, "narfi -c4 -q wide          \n");
        fprintf(stderr, "narfi -c4 -r wide          \n");
        fprintf(stderr, "narfi -c4 -s, wide         \n");
        fprintf(stderr, "narfi -c4 -s\\l wide        \n");
        fprintf(stderr, "narfi -c4 -s\\l -x- csv     \n");
        fprintf(stderr, "narfi -c4 -s\\x7C wide      \n");
        fprintf(stderr, "narfi -c4 -z256 wide       \n");
        fprintf(stderr, "narfi -c255 -f wide        \n");
        fprintf(stderr, "narfi -V                   \n");
        fprintf(stderr, "narfi -VC                  \n");
    }

    exit(1);
}
