#include "leaf.h"

/*
typedef char* FIELD_POINTER;
*/
FIELD_POINTER array_of_fields[FIELD_COUNT];
FIELD_POINTER *fields_list = & array_of_fields[0];
LEAF o;
LEAF *stem = &o;
static int BOND_SIZE = sizeof(char);
static int LEAF_SIZE = sizeof(LEAF);

LEAF *sprout(LEAF *left, char *p) {
    int leaf_size = strlen(p);
    static int leaf_number;
    LEAF *right = malloc(LEAF_SIZE);
    if(right == NULL) {
        fprintf(stderr, "sprout() error: %d\n", leaf_number);
        exit(1);
    }

    leaf_number += 1;
    left->right = right;
    right->left = left;
    right->right = NULL;
    right->leaf_number = leaf_number;
    right->leaf = malloc( leaf_size + 1 );
    if(right->leaf == NULL) {
        fprintf(stderr, "malloc() error-3: %d bytes\n",  leaf_size + 1 );
        exit(1);
    }

    strcpy(right->leaf, p);
    return right;
}

int creep(LEAF *beginning, char *p, BOOL reverse) {
    int leaf_number = STEM;
    LEAF *left;
    LEAF *right;

    if(reverse) {
        right = beginning;
        for(;;) {
            if(! strcmp(right->leaf, p) ) {
                leaf_number = right->leaf_number;
                break;
            }

            left = right->left;
            if(left == stem) {
                break;
            }

            right = left;
        }

    } else {
        left = beginning;
        for(;;) {
            if(! strcmp(left->leaf, p) ) {
                leaf_number = left->leaf_number;
                break;
            }

            right = left->right;
            if(right == NULL) {
                break;
            }

            left = right;
        }

    }

    return leaf_number;
}

void leafy_tree(LEAF *beginning, char *combo, int separator) {
    char delimiter[2] = {0, 0};
    int m;
    LEAF *left;
    LEAF *right;

    combo[0] = '\0';
    m = 0x00FF & separator;
    delimiter[0] = (char)m;
    left = beginning;
    for(;;) {
        strcat(combo, left->leaf);
        strcat(combo, delimiter);
        right = left->right;
        if(right == NULL) {
            break;
        }

        left = right;
    }

}

void linked_list_to_array_arranging_in_reverse_order(LEAF *beginning) {
    int k = 0;
    LEAF *left;
    LEAF *right;

    right = beginning;
    for(;;) {
        fields_list[k++] = right->leaf;
        left = right->left;
        if(left == stem) {
            break;
        }

        right = left;
    }

}

void linked_list_to_array_complementing(LEAF *beginning, char *extra, int bond, int buffer_size) {
    char *p;
    char delimiter[2] = {0, 0};
    int extra_size = strlen(extra);
    int k = 0;
    int m;
    int size = buffer_size + BOND_SIZE + extra_size + 1;
    LEAF *left;
    LEAF *right;

    m = 0x00FF & bond;
    delimiter[0] = (char)m;
    left = beginning;
    for(;;) {
        p = malloc(size);
        strcpy(p, left->leaf);
        strcat(p, delimiter);
        strcat(p, extra);

        free(left->leaf);
        left->leaf = p;
        fields_list[k++] = p;

        right = left->right;
        if(right == NULL) {
            break;
        }

        left = right;
    }

}

void linked_list_to_array_editing(LEAF *beginning, EDIT_FUNCTION editing, int field_number, int buffer_size) {
    char *p;
    int field_number_1 = field_number - 1;
    int k = 0;
    int SIZE = buffer_size * EDIT_FUNCTION_FACTOR;
    int SIZE_1 = SIZE - 1;
    LEAF *left;
    LEAF *right;

    left = beginning;
    for(;;) {
        p = malloc(SIZE);
        if(p == NULL) {
            fprintf(stderr, "malloc() error-4: %d bytes\n", SIZE);
            exit(1);
        }

        if(k == field_number_1) {
            p[SIZE_1] = '\0';
            strncpy(p, editing(left->leaf), SIZE_1);
        } else {
            strcpy(p, left->leaf);
        }

        free(left->leaf);
        left->leaf = p;
        fields_list[k++] = p;
        right = left->right;
        if(right == NULL) {
            break;
        }

        left = right;
    }

}

void linked_list_to_array_mapping(LEAF *beginning) {
    int k = 0;
    LEAF *left;
    LEAF *right;

    left = beginning;
    for(;;) {
        fields_list[k++] = left->leaf;
        right = left->right;
        if(right == NULL) {
            break;
        }

        left = right;
    }

}

void lose_leaves(LEAF *right) {
    LEAF *left;

    for(;;) {
        free(right->leaf);
        right->leaf = NULL;

        left = right->left;
        free(right);
        if(left == stem) {
            break;
        }

        right = left;
    }

}
