#ifndef NARFI_H
#define NARFI_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif

#define VERSION 1.06
#define ASCII_SIZE 1
#define BELL 0x07
#define BELL_ASCII_KATAKANA_COUNT 224
#define BUFFER_SIZE 524288 /* 512 KB */
#define COMMA ','
#define DECIMAL_FIELD_SIZE 512
#define ERROR_TEXT "error.txt"
#define HE 0xCD /* "" Shift_JIS */
#define KANA_DAKUTEN 0xDE
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KATAKANA_SIZE 1
#define NARFI_TEXT "narfi.txt"
#define ZENKAKU_SIZE 2
#define ZENKAKU_SIZE_1 3
#include "dividing.h"
#include "line.h"
#include "numbered.h"

enum EDITING_METHOD {
    NEITHER_EXTRACT_NOR_REMOVE,
    EXTRACT_DECIMAL_FROM_FIELD,
    EXTRACT_INTEGER_FROM_FIELD,
    REMOVE_CONTROL_CHARACTERS_FROM_FIELD,
    REPLACE_KATAKANA_WITH_ASCII,
    METHOD_COUNT
};

typedef struct KANA_ASCII KANA_ASCII;
struct KANA_ASCII {
    char *buffer;
    char *combo;
    int ascii, buffer_size;
};

BOOL setting(KANA_ASCII *kana, long z, int ascii);
FIELD_POINTER extract_decimal(FIELD_POINTER p);
FIELD_POINTER extract_integer(FIELD_POINTER p);
FIELD_POINTER remove_control(FIELD_POINTER p);
FIELD_POINTER skip_control_characters_to_abolish_hankaku(FIELD_POINTER p);
FIELD_POINTER transparent(FIELD_POINTER p);
int counting(char *file_name, long z, int separator, int field_count, BOOL remove_separators);
int punctuation(char *p, int q);
int selecting(char *file_name, char *bits, char *new_name, long z, int separator, int field_count, BOOL remove_separators, BOOL reverse);
int selecting_editing(char *file_name, char *new_name, long z, int separator, int field_count, int field_number, int editing, BOOL remove_separators);
int standard_input_output(char *bits, long z, int separator, int field_count, BOOL remove_separators, BOOL reverse);
int standard_input_output_counting(long z, int separator, int field_count, BOOL remove_separators);
int standard_input_output_editing(long z, int separator, int field_count, int field_number, int editing, BOOL remove_separators);
void detach_buffers(KANA_ASCII *kana);
void error_handler(const char *p, char *q);
void version_guide(double v, BOOL comments);

#endif /* NARFI_H */
