#include "narfi.h"

/*
narfi C-1.06
Selecting fields from CSV to produce a narrow file
Copyright 2019 Sogaya

gcc (GCC) 3.4.2 (mingw-special)
Open Watcom C32 Optimizing Compiler Version 1.8 J001
Borland C++ 5.5.1 for Win32
Digital Mars Compiler Version 8.42n (Digital Mars C/C++ Compiler Version 8.57)
Embarcadero C++ 7.30 for Win32

*/

char bits[ FIELD_COUNT + 1 ];
KANA_ASCII kana_ascii;
KANA_ASCII *kana = &kana_ascii;

BOOL extension_equals_CSV(char *p) {
    BOOL csv = FALSE;
    char *extention;
    char CAPITAL_CSV[] = "CSV";
    char CSV[] = "csv";
    char DOT[] = ".";
    const int DOT_SIZE = 1;

    char *q = strstr(p, DOT);
    if(q != NULL) {
        extention = q + DOT_SIZE;
        if(! strcmp(CSV, extention) ) {
            csv = TRUE;
        } else if(! strcmp(CAPITAL_CSV, extention) ) {
            csv = TRUE;
        }

    }

    return csv;
}

BOOL setting(KANA_ASCII *kana, long z, int ascii) {
    BOOL b = TRUE;

    kana->ascii = ascii;
    kana->buffer_size = (int)z;

    kana->buffer = malloc(kana->buffer_size);
    if(kana->buffer == NULL) {
        fprintf(stderr, "malloc() error-12: %d\n", kana->buffer_size);
        b = FALSE;
    }

    kana->combo = malloc( kana->buffer_size * ASCII_SIZE );
    if(kana->combo == NULL) {
        fprintf(stderr, "malloc() error-13: %d\n", kana->buffer_size * ASCII_SIZE );
        b = FALSE;
    }

    return b;
}

int main(int argc, char *argv[]) {
    const BOOL WITH_COMMENTS = TRUE;
    const BOOL WITHOUT_COMMENTS = FALSE;
    const int A_SUBSTITUTE_TERM_SIZE = 2;
    const int BITS_SIZE = 2;
    const int ERROR_CODE = 1;
    const int NEW_LINE_ZERO = 2; /* buffer shall include '\n' and '\0'. */
    const int NONE = 0;
    const int SEPARATOR_TERM_SIZE = 2;
    char ALL_LINES_SHARE_FIELD_COUNT[] = "-f";
    char A_SUBSTITUTE[] = "-a";
    char BITS[] = "-b";
    char DO_NOT_CHECK_EXTENSION[] = "-x-";
    char EXTRACT_DECIMAL[] = "-e";
    char EXTRACT_INTEGER[] = "-n";
    char FIELD_COUNT_TERM[] = "-c";
    char INTERVAL[] = "-i";
    char LINE_BUFFER_SIZE[] = "-l";
    char QUOTES[] = "-q";
    char REMOVE_CONTROL[] = "-o";
    char REPLACE_KATAKANA[] = "-k";
    char REVERSE[] = "-r";
    char SEPARATOR[] = "-s";
    char SIZE_OF_BUFFER[] = "-z";
    char VERSION_WITH_COMMENTS[] = "-VC";
    char VERSION_WITHOUT_COMMENTS[] = "-V";

    BOOL check_extension = TRUE;
    BOOL check_field_count = FALSE;
    BOOL carriage_return = FALSE;
    BOOL csv = FALSE;
    BOOL file_to_be_read = TRUE;
    BOOL line_buffer_size = FALSE;
    BOOL remove_separators = FALSE;
    BOOL reverse = FALSE;
    BOOL surge = FALSE;
    char *buffer;
    char *edge;
    char *q;
    char *supplied;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char new_name[ FILE_NAME_SIZE + 1 ];
    int ascii = '_'; // 0x5F
    int body_length = 1;
    int buffer_size = BUFFER_SIZE;
    int demands = FIELD_COUNT;
    int direction = 1; /* direction > 0 */
    int edited_field_number = NONE;
    int editing = NEITHER_EXTRACT_NOR_REMOVE;
    int exit_code = 0;
    int field_count = FIELD_COUNT;
    int file_name_size, i, line_count, line_number, maximum, maximum_line_length, new_line_length;
    int from = 1;
    int interval_0 = from;
    int to = 1;
    int interval_1 = to;
    int separator = COMMA;
    long z = (long)BUFFER_SIZE;
    NUMBERED o;
    NUMBERED *n = &o;

    memset(file_name, 0, FILE_NAME_SIZE + 1 );
    strcpy(new_name, NARFI_TEXT);
    supplying_bits(bits, &field_count);

    for(i = 1; i < argc; ++i) {
        if(! strcmp(ALL_LINES_SHARE_FIELD_COUNT, argv[i]) ) {
            check_field_count = TRUE;
        } else if(! strcmp(DO_NOT_CHECK_EXTENSION, argv[i]) ) {
            check_extension = FALSE;
        } else if(! strcmp(LINE_BUFFER_SIZE, argv[i]) ) {
            line_buffer_size = TRUE;
        } else if(! strcmp(QUOTES, argv[i]) ) {
            remove_separators = TRUE;
        } else if(! strcmp(REVERSE, argv[i]) ) {
            reverse = TRUE;
        } else if(! strcmp(VERSION_WITH_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITH_COMMENTS);
        } else if(! strcmp(VERSION_WITHOUT_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argv[i];
            edge = & q[0];

            q = strstr(argv[i], A_SUBSTITUTE);
            if(q == edge) {
                ascii = punctuation(argv[i], A_SUBSTITUTE_TERM_SIZE);
                continue;
            }

            q = strstr(argv[i], BITS);
            if(q == edge) {
                q += BITS_SIZE;
                body_length = strlen(q);
                if(body_length > field_count) {
                    body_length = field_count;
                    memcpy(bits, q, body_length);
                    bits[body_length] = '\0';
                } else {
                    demands = field_count - body_length;
                    supplied = malloc( demands + 1 );
                    if(supplied == NULL) {
                        fprintf(stderr, "malloc() error-7: %d bytes", demands);
                        return ERROR_CODE;
                    }

                    supplied[demands] = '\0';
                    memset(supplied, SET, demands);
                    strcpy(bits, q);
                    strcat(bits, supplied);
                    free(supplied);
                }

                continue;
            }

            q = strstr(argv[i], EXTRACT_DECIMAL);
            if(q == edge) {
                numbered(n, argv[i]);
                edited_field_number = number(n);
                if(! strcmp(EXTRACT_DECIMAL, parameter(n) ) ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = EXTRACT_DECIMAL_FROM_FIELD;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = strstr(argv[i], EXTRACT_INTEGER);
            if(q == edge) {
                numbered(n, argv[i]);
                edited_field_number = number(n);
                if(! strcmp(EXTRACT_INTEGER, parameter(n) ) ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = EXTRACT_INTEGER_FROM_FIELD;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = strstr(argv[i], FIELD_COUNT_TERM);
            if(q == edge) {
                numbered(n, argv[i]);
                field_count = number(n);
                if(! strcmp(FIELD_COUNT_TERM, parameter(n) ) ) {
                    if(field_count == NOT_CONVERTED) {
                        field_count = FIELD_COUNT;
                    }

                    continue;
                }

                field_count = FIELD_COUNT;
            }

            q = strstr(argv[i], INTERVAL);
            if(q == edge) {
                numbered_less_than_final(n, argv[i], FIELD_COUNT);
                if( trimmed_sequence(n) ) {
                    interval_1 = number(n);
                    interval_0 = subnumber(n);
                    if(! strcmp(INTERVAL, parameter(n) ) ) {
                        if(interval_0 == NOT_CONVERTED) {
                            interval_0 = 1;
                            interval_1 = 1;
                        }

                        direction = interval_1 - interval_0;
                        if(direction >= 0) {
                            from = interval_0;
                            to = interval_1;
                            surge = TRUE;
                            continue;
                        } else {
                            from = interval_1;
                            to = interval_0;
                            surge = TRUE;
                            continue;
                        }

                    }

                }

                interval_0 = 1;
                interval_1 = 1;
            }

            q = strstr(argv[i], REMOVE_CONTROL);
            if(q == edge) {
                numbered(n, argv[i]);
                edited_field_number = number(n);
                if(! strcmp(REMOVE_CONTROL, parameter(n) ) ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = REMOVE_CONTROL_CHARACTERS_FROM_FIELD;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = strstr(argv[i], REPLACE_KATAKANA);
            if(q == edge) {
                numbered(n, argv[i]);
                edited_field_number = number(n);
                if(! strcmp(REPLACE_KATAKANA, parameter(n) ) ) {
                    if(edited_field_number == NOT_CONVERTED) {
                        edited_field_number = NONE;
                        editing = NEITHER_EXTRACT_NOR_REMOVE;
                    } else {
                        editing = REPLACE_KATAKANA_WITH_ASCII;
                    }

                    continue;
                }

                edited_field_number = NONE;
                editing = NEITHER_EXTRACT_NOR_REMOVE;
            }

            q = strstr(argv[i], SEPARATOR);
            if(q == edge) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            q = strstr(argv[i], SIZE_OF_BUFFER);
            if(q != NULL) {
                numbered(n, argv[i]);
                buffer_size = number(n);
                if(! strcmp(SIZE_OF_BUFFER, parameter(n) ) ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            if(file_to_be_read) {
                file_name[FILE_NAME_SIZE] = '\0';
                strncpy(file_name, argv[i], FILE_NAME_SIZE);
                file_to_be_read = FALSE;
            } else {
                new_name[FILE_NAME_SIZE] = '\0';
                strncpy(new_name, argv[i], FILE_NAME_SIZE);
            }

        } /* if */

    } /* for(i = 1; i < argc; ++i) */

    if(surge) {
        surge_of_set_bits(bits, field_count, from, to);
    }

    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        z = (long)buffer_size;
        if(line_buffer_size) {
            fprintf(stdout, "%d bytes\n", buffer_size);
        }

        if(edited_field_number == NONE) {
            if(check_field_count) {
                exit_code = standard_input_output_counting(z, separator, field_count, remove_separators);
            } else {
                exit_code = standard_input_output(bits, z, separator, field_count, remove_separators, reverse);
            }

        } else {
            switch(editing) {
            case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
                if(! setting(kana, z, ascii) ) {
                    return ERROR_CODE;
                }

                exit_code = standard_input_output_editing(z, separator, field_count, edited_field_number, editing, remove_separators);
                detach_buffers(kana);
                break;
            case REPLACE_KATAKANA_WITH_ASCII:
                if(! setting(kana, z, ascii) ) {
                    return ERROR_CODE;
                }

                exit_code = standard_input_output_editing(z, separator, field_count, edited_field_number, editing, remove_separators);
                detach_buffers(kana);
                break;
            default:
                exit_code = standard_input_output_editing(z, separator, field_count, edited_field_number, editing, remove_separators);
                break;
            }

        }

        return exit_code;
    }

    if(buffer_size == BUFFER_SIZE) {
        buffer_size = (int)file_size(file_name);
        if(buffer_size >= 0) {
            buffer_size += 1;
            buffer = malloc(buffer_size);
            if(buffer != NULL) {
                FILE *p = fopen(file_name, "rb");
                fread(buffer, buffer_size, 1, p);
                maximum = maximum_LF_to_LF_span(&line_count, &line_number, &carriage_return, buffer, buffer_size);
                new_line_length = carriage_return ? 2 : 1;
                maximum_line_length = maximum - new_line_length;
                fclose(p);
                free(buffer);

                buffer_size = maximum_line_length + NEW_LINE_ZERO;
            }

        } else {
            fprintf(stderr, "file_size() error: %d\n", buffer_size);
            return ERROR_CODE;
        }

    }

    z = (long)buffer_size;
    if(line_buffer_size) {
        fprintf(stdout, "%d bytes\n", buffer_size);
    }

    if(check_extension) {
        csv = extension_equals_CSV(file_name);
        if(csv) {
            separator = COMMA;
        }

    }

    if(edited_field_number == NONE) {
        if(check_field_count) {
            exit_code = counting(file_name, z, separator, field_count, remove_separators);
        } else {
            exit_code = selecting(file_name, bits, new_name, z, separator, field_count, remove_separators, reverse);
        }

    } else {
        switch(editing) {
        case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
            if(! setting(kana, z, ascii) ) {
                return ERROR_CODE;
            }

            exit_code = selecting_editing(file_name, new_name, z, separator, field_count, edited_field_number, editing, remove_separators);
            detach_buffers(kana);
            break;
        case REPLACE_KATAKANA_WITH_ASCII:
            if(! setting(kana, z, ascii) ) {
                return ERROR_CODE;
            }

            exit_code = selecting_editing(file_name, new_name, z, separator, field_count, edited_field_number, editing, remove_separators);
            detach_buffers(kana);
            break;
        default:
            exit_code = selecting_editing(file_name, new_name, z, separator, field_count, edited_field_number, editing, remove_separators);
            break;
        }

    }

    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: /* 0xCD */
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
