#include "narfi.h"

static int NEW_NAME_ERROR = 2;
static int ERROR_CODE = 1;

int selecting(char *file_name, char *bits, char *new_name, long z, int separator, int field_count, BOOL remove_separators, BOOL way_of_arranging) {
    BOOL full_house = FALSE;
    char *buffer;
    char *combo;
    char *p;
    char few_fields;
    DIVIDING dividing;
    DIVIDING *d = &dividing;
    FILE *file;
    int buffer_size = (int)z;
    int exit_code = 0;
    FILE *new_file = fopen(new_name, "wt");
    if(new_file == NULL) {
        exit_code = NEW_NAME_ERROR;
        error_handler("fopen() error:", new_name);
        new_file = fopen(NARFI_TEXT, "wt");
    }

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-8: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    combo = malloc( MINIMUM_COMBO_SIZE + buffer_size );
    if(combo == NULL) {
        fprintf(stderr, "combo == NULL error-1: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "fopen() error: %s\n", file_name);
        return ERROR_CODE;;
    }

    if(way_of_arranging) {
/*        full_house = TRUE; */

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                reverse_unite(d, buffer, combo);
                fprintf(new_file, "%s\n", combo);
                release_arrays(d);
            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
                reverse_unite(d, buffer, combo);
                fprintf(new_file, "%s\n", combo);
                release_arrays(d);
            }

        }

    } else {
        p = strchr(bits, CLEAR);
        if(p == NULL) {
            full_house = TRUE;
        }

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                    unite(d, buffer, combo);
                    fprintf(new_file, "%s\n", combo);
                    release_arrays(d);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, file);
                    if(p == NULL) {
                        break;
                    }

                    dividing_into_few_fields(d, bits, buffer_size, separator, few_fields, remove_separators);
                    unite(d, buffer, combo);
                    fprintf(new_file, "%s\n", combo);
                    release_arrays(d);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, file);
                if(p == NULL) {
                    break;
                }

                dividing_into_fields(d, bits, buffer_size, separator, field_count, remove_separators);
                unite(d, buffer, combo);
                fprintf(new_file, "%s\n", combo);
                release_arrays(d);
            }

        }

    }

    fclose(file);
    fclose(new_file);
    free(buffer);
    free(combo);
    return exit_code;
}

int selecting_editing(char *file_name, char *new_name, long z, int separator, int field_count, int field_number, int editing, BOOL remove_separators) {
    char *buffer;
    char *combo;
    char *p;
    char few_fields;
    DIVIDING dividing;
    DIVIDING *d = &dividing;
    EDIT_FUNCTION extracting = extract_decimal;
    FILE *file;
    int buffer_size = (int)z;
    int exit_code = 0;
    LEAF *left = NULL;
    FILE *new_file = fopen(new_name, "wt");
    if(new_file == NULL) {
        exit_code = NEW_NAME_ERROR;
        error_handler("fopen() error:", new_name);
        new_file = fopen(NARFI_TEXT, "wt");
    }

    buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-9: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    combo = malloc( MINIMUM_COMBO_SIZE + buffer_size );
    if(combo == NULL) {
        fprintf(stderr, "combo == NULL error-2: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "fopen() error: %s\n", file_name);
        return ERROR_CODE;;
    }

    switch(editing) {
    case NEITHER_EXTRACT_NOR_REMOVE:
        extracting = transparent;
        break;
    case EXTRACT_DECIMAL_FROM_FIELD:
//        extracting = extract_decimal;
        break;
    case EXTRACT_INTEGER_FROM_FIELD:
        extracting = extract_integer;
        break;
    case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
        extracting = remove_control;
        break;
    case REPLACE_KATAKANA_WITH_ASCII:
        extracting = skip_control_characters_to_abolish_hankaku;
        break;
    default:
        extracting = extract_decimal;
        break;
    }

    if(field_count <= 0x00FF) { /* 0 to 255 */
        few_fields = (char)field_count;

        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
            left = editing_fields_list(d, buffer, extracting, field_number);
            unite_fields(d, left, buffer, combo);
            fprintf(new_file, "%s\n", combo);
            release_arrays(d);
        }

    } else {
        for(;;) {
            p = fgets(buffer, buffer_size, file);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
            left = editing_fields_list(d, buffer, extracting, field_number);
            unite_fields(d, left, buffer, combo);
            fprintf(new_file, "%s\n", combo);
            release_arrays(d);
        }

    }

    fclose(file);
    fclose(new_file);
    free(buffer);
    free(combo);
    return exit_code;
}

void detach_buffers(KANA_ASCII *kana) {
    free(kana->buffer);
    free(kana->combo);
}

void error_handler(const char *p, char *q) {
    FILE *file = fopen(ERROR_TEXT, "wt");
    fprintf(file, "%s %s", p, q);;
    fclose(file);
}

