#include "narfi.h"

static int ERROR_CODE = 1;

int standard_input_output(char *bits, long z, int separator, int field_count, BOOL remove_separators, BOOL way_of_arranging) {
    BOOL full_house = FALSE;
    char *combo;
    char *p;
    char few_fields;
    DIVIDING dividing;
    DIVIDING *d = &dividing;
    int buffer_size = (int)z;
    int exit_code = 0;
    char *buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-10: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    combo = malloc( MINIMUM_COMBO_SIZE + buffer_size );
    if(combo == NULL) {
        fprintf(stderr, "combo == NULL error-3: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    if(way_of_arranging) {
/*        full_house = TRUE; */

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                reverse_unite(d, buffer, combo);
                fprintf(stdout, "%s\n", combo);
                release_arrays(d);
            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
                reverse_unite(d, buffer, combo);
                fprintf(stdout, "%s\n", combo);
                release_arrays(d);
            }

        }

    } else {
        p = strchr(bits, CLEAR);
        if(p == NULL) {
            full_house = TRUE;
        }

        if(field_count <= 0x00FF) { /* 0 to 255 */
            few_fields = (char)field_count;

            if(full_house) {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
                    unite(d, buffer, combo);
                    fprintf(stdout, "%s\n", combo);
                    release_arrays(d);
                }

            } else {
                for(;;) {
                    p = fgets(buffer, buffer_size, stdin);
                    if(p == NULL) {
                        break;
                    }

                    dividing_into_few_fields(d, bits, buffer_size, separator, few_fields, remove_separators);
                    unite(d, buffer, combo);
                    fprintf(stdout, "%s\n", combo);
                    release_arrays(d);
                }

            }

        } else {
            for(;;) {
                p = fgets(buffer, buffer_size, stdin);
                if(p == NULL) {
                    break;
                }

                dividing_into_fields(d, bits, buffer_size, separator, field_count, remove_separators);
                unite(d, buffer, combo);
                fprintf(stdout, "%s\n", combo);
                release_arrays(d);
            }

        }

    }

    free(buffer);
    free(combo);
    return exit_code;
}

int standard_input_output_editing(long z, int separator, int field_count, int field_number, int editing, BOOL remove_separators) {
    char *combo;
    char *p;
    char few_fields;
    DIVIDING dividing;
    DIVIDING *d = &dividing;
    EDIT_FUNCTION extracting = extract_decimal;
    int buffer_size = (int)z;
    int exit_code = 0;
    LEAF *left = NULL;
    char *buffer = malloc(buffer_size);
    if(buffer == NULL) {
        fprintf(stderr, "malloc() error-11: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    combo = malloc( MINIMUM_COMBO_SIZE + buffer_size );
    if(combo == NULL) {
        fprintf(stderr, "combo == NULL error-4: %d bytes\n", buffer_size);
        return ERROR_CODE;
    }

    switch(editing) {
    case NEITHER_EXTRACT_NOR_REMOVE:
        extracting = transparent;
        break;
    case EXTRACT_DECIMAL_FROM_FIELD:
//        extracting = extract_decimal;
        break;
    case EXTRACT_INTEGER_FROM_FIELD:
        extracting = extract_integer;
        break;
    case REMOVE_CONTROL_CHARACTERS_FROM_FIELD:
        extracting = remove_control;
        break;
    case REPLACE_KATAKANA_WITH_ASCII:
        extracting = skip_control_characters_to_abolish_hankaku;
        break;
    default:
        extracting = extract_decimal;
        break;
    }

    if(field_count <= 0x00FF) { /* 0 to 255 */
        few_fields = (char)field_count;

        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_few_fields(d, buffer_size, separator, few_fields, remove_separators);
            left = editing_fields_list(d, buffer, extracting, field_number);
            unite_fields(d, left, buffer, combo);
            fprintf(stdout, "%s\n", combo);
            release_arrays(d);
        }

    } else {
        for(;;) {
            p = fgets(buffer, buffer_size, stdin);
            if(p == NULL) {
                break;
            }

            full_house_dividing_into_fields(d, buffer_size, separator, field_count, remove_separators);
            left = editing_fields_list(d, buffer, extracting, field_number);
            unite_fields(d, left, buffer, combo);
            fprintf(stdout, "%s\n", combo);
            release_arrays(d);
        }

    }

    free(buffer);
    free(combo);
    return exit_code;
}
